Loading...
Searching...
No Matches
elastix::AdaptiveStochasticVarianceReducedGradient< TElastix > Class Template Reference
Components » Optimizers

`#include <elxAdaptiveStochasticVarianceReducedGradient.h>`

## Detailed Description

template<class TElastix>
class elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >

A gradient descent optimizer with an adaptive gain.

This class is a wrap around the AdaptiveStochasticVarianceReducedGradientOptimizer class. It takes care of setting parameters and printing progress information. For more information about the optimization method, please read the documentation of the AdaptiveStochasticVarianceReducedGradientOptimizer class.

This optimizer is very suitable to be used in combination with the Random image sampler, or with the RandomCoordinate image sampler, with the setting (NewSamplesEveryIteration "true"). Much effort has been spent on providing reasonable default values for all parameters, to simplify usage. In most registration problems, good results should be obtained without specifying any of the parameters described below (except the first of course, which defines the optimizer to use).

This optimization method is described in the following references:

[1] P. Cruz Almost sure convergence and asymptotical normality of a generalization of Kesten's stochastic approximation algorithm for multidimensional case Technical Report, 2005. http://hdl.handle.net/2052/74

[2] S. Klein, J.P.W. Pluim, and M. Staring, M.A. Viergever, Adaptive stochastic gradient descent optimisation for image registration International Journal of Computer Vision, vol. 81, no. 3, pp. 227-239, 2009 http://dx.doi.org/10.1007/s11263-008-0168-y

Acceleration in case of many transform parameters was proposed in the following paper:

[3] Y.Qiao, B.P.F. Lelieveldt, M.Staring Fast Automatic Step Size Estimation for Gradient Descent Optimization of Image Registration IEEE Transactions on Medical Imaging, vol. 35, no. 2, pp. 391 - 403, February 2016 http://dx.doi.org/10.1109/TMI.2015.2476354

The parameters used in this class are:

Parameters

  Optimizer: Select this optimizer as follows:
  (Optimizer "AdaptiveStochasticVarianceReducedGradient")

  MaximumNumberOfIterations: The maximum number of iterations in each resolution.
  example: (MaximumNumberOfIterations 100 100 50)
  Default/recommended value: 500. When you are in a hurry, you may go down to 250 for example. When you have plenty of time, and want to be absolutely sure of the best results, a setting of 2000 is reasonable. In general, 500 gives satisfactory results.

  MaximumNumberOfSamplingAttempts: The maximum number of sampling attempts. Sometimes not enough corresponding samples can be drawn, upon which an exception is thrown. With this parameter it is possible to try to draw another set of samples.
  example: (MaximumNumberOfSamplingAttempts 10 15 10)
  Default value: 0, i.e. just fail immediately, for backward compatibility.

  AutomaticParameterEstimation: When this parameter is set to "true", many other parameters are calculated automatically: SP_a, SP_alpha, SigmoidMax, SigmoidMin, and SigmoidScale. In the elastix.log file the actually chosen values for these parameters can be found.
  example: (AutomaticParameterEstimation "true")
  Default/recommended value: "true". The parameter can be specified for each resolution, or for all resolutions at once.

  UseAdaptiveStepSizes: When this parameter is set to "true", the adaptive step size mechanism described in the documentation of itk::AdaptiveStochasticVarianceReducedGradientOptimizer is used. The parameter can be specified for each resolution, or for all resolutions at once.
  example: (UseAdaptiveStepSizes "true")
  Default/recommend value: "true", because it makes the registration more robust. In case of using a RandomCoordinate sampler, with (UseRandomSampleRegion "true"), the adaptive step size mechanism is turned off, no matter the user setting.

  MaximumStepLength: Also called . This parameter can be considered as the maximum voxel displacement between two iterations. The larger this parameter, the more agressive the optimization. The parameter can be specified for each resolution, or for all resolutions at once.
  example: (MaximumStepLength 1.0)
  Default: mean voxel spacing of fixed and moving image. This seems to work well in general. This parameter only has influence when AutomaticParameterEstimation is used.

  SP_a: The gain at each iteration is defined by
  .
  SP_a can be defined for each resolution.
  example: (SP_a 3200.0 3200.0 1600.0)
  The default value is 400.0. Tuning this variable for you specific problem is recommended. Alternatively set the AutomaticParameterEstimation to "true". In that case, you do not need to specify SP_a. SP_a has no influence when AutomaticParameterEstimation is used.

  SP_A: The gain at each iteration is defined by
  .
  SP_A can be defined for each resolution.
  example: (SP_A 50.0 50.0 100.0)
  The default/recommended value for this particular optimizer is 20.0.

  SP_alpha: The gain at each iteration is defined by
  .
  SP_alpha can be defined for each resolution.
  example: (SP_alpha 0.602 0.602 0.602)
  The default/recommended value for this particular optimizer is 1.0. Alternatively set the AutomaticParameterEstimation to "true". In that case, you do not need to specify SP_alpha. SP_alpha has no influence when AutomaticParameterEstimation is used.

  SigmoidMax: The maximum of the sigmoid function ( ). Must be larger than 0. The parameter can be specified for each resolution, or for all resolutions at once.
  example: (SigmoidMax 1.0)
  Default/recommended value: 1.0. This parameter has no influence when AutomaticParameterEstimation is used. In that case, always a value 1.0 is used.

  SigmoidMin: The minimum of the sigmoid function ( ). Must be smaller than 0. The parameter can be specified for each resolution, or for all resolutions at once.
  example: (SigmoidMin -0.8)
  Default value: -0.8. This parameter has no influence when AutomaticParameterEstimation is used. In that case, the value is automatically determined, depending on the images, metric etc.

  SigmoidScale: The scale/width of the sigmoid function ( ). The parameter can be specified for each resolution, or for all resolutions at once.
  example: (SigmoidScale 0.00001)
  Default value: 1e-8. This parameter has no influence when AutomaticParameterEstimation is used. In that case, the value is automatically determined, depending on the images, metric etc.

  SigmoidInitialTime: the initial time input for the sigmoid ( ). Must be larger than 0.0. The parameter can be specified for each resolution, or for all resolutions at once.
  example: (SigmoidInitialTime 0.0 5.0 5.0)
  Default value: 0.0. When increased, the optimization starts with smaller steps, leaving the possibility to increase the steps when necessary. If set to 0.0, the method starts with with the largest step allowed.

  NumberOfGradientMeasurements: Number of gradients N to estimate the average square magnitudes of the exact gradient and the approximation error. The parameter can be specified for each resolution, or for all resolutions at once.
  example: (NumberOfGradientMeasurements 10)
  Default value: 0, which means that the value is automatically estimated. In principle, the more the better, but the slower. In practice N=10 is usually sufficient. But the automatic estimation achieved by N=0 also works good. The parameter has only influence when AutomaticParameterEstimation is used.

  NumberOfJacobianMeasurements: The number of voxels M where the Jacobian is measured, which is used to estimate the covariance matrix. The parameter can be specified for each resolution, or for all resolutions at once.
  example: (NumberOfJacobianMeasurements 5000 10000 20000)
  Default value: M = max( 1000, nrofparams ), with nrofparams the number of transform parameters. This is a rather crude rule of thumb, which seems to work in practice. In principle, the more the better, but the slower. The parameter has only influence when AutomaticParameterEstimation is used.

  NumberOfSamplesForExactGradient: The number of image samples used to compute the 'exact' gradient. The samples are chosen on a uniform grid. The parameter can be specified for each resolution, or for all resolutions at once.
  example: (NumberOfSamplesForExactGradient 100000)
  Default/recommended: 100000. This works in general. If the image is smaller, the number of samples is automatically reduced. In principle, the more the better, but the slower. The parameter has only influence when AutomaticParameterEstimation is used.

  ASGDParameterEstimationMethod: The ASGD parameter estimation method used in this optimizer. The parameter can be specified for each resolution.
  example: (ASGDParameterEstimationMethod "Original")
  or (ASGDParameterEstimationMethod "DisplacementDistribution")
  Default: Original.

  MaximumDisplacementEstimationMethod: The suitable position selection method used only for displacement distribution estimation method. The parameter can be specified for each resolution.
  example: (MaximumDisplacementEstimationMethod "2sigma")
  or (MaximumDisplacementEstimationMethod "95percentile")
  Default: 2sigma.

  NoiseCompensation: Selects whether or not to use noise compensation. The parameter can be specified for each resolution, or for all resolutions at once.
  example: (NoiseCompensation "true")
  Default/recommended: true.

Todo
  : this class contains a lot of functional code, which actually does not belong here.

See also
  AdaptiveStochasticVarianceReducedGradientOptimizer

Definition at line 193 of file elxAdaptiveStochasticVarianceReducedGradient.h.

Inheritance diagram for elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >:
[legend]

## Data Structures

struct | MultiThreaderParameterType

## Public Types

using | ConstPointer = itk::SmartPointer<const Self>
using | ITKBaseType = typename Superclass2::ITKBaseType
using | Pointer = itk::SmartPointer<Self>
using | Self = AdaptiveStochasticVarianceReducedGradient
using | SizeValueType = itk::SizeValueType
using | Superclass1 = AdaptiveStochasticVarianceReducedGradientOptimizer
using | Superclass2 = OptimizerBase<TElastix>
using | ThreadIdType = unsigned int
Public Types inherited from itk::AdaptiveStochasticVarianceReducedGradientOptimizer
using | ConstPointer = SmartPointer<const Self>
using | Pointer = SmartPointer<Self>
using | Self = AdaptiveStochasticVarianceReducedGradientOptimizer
using | Superclass = StandardStochasticVarianceReducedGradientOptimizer
Public Types inherited from itk::StandardStochasticVarianceReducedGradientOptimizer
using | ConstPointer = SmartPointer<const Self>
using | Pointer = SmartPointer<Self>
using | Self = StandardStochasticVarianceReducedGradientOptimizer
enum | StopConditionType
using | Superclass = StochasticVarianceReducedGradientDescentOptimizer
Public Types inherited from itk::StochasticVarianceReducedGradientDescentOptimizer
using | ConstPointer = SmartPointer<const Self>
using | Pointer = SmartPointer<Self>
using | ScaledCostFunctionPointer
using | ScaledCostFunctionType
using | ScalesType
using | Self = StochasticVarianceReducedGradientDescentOptimizer
enum | StopConditionType { MaximumNumberOfIterations , MetricError , MinimumStepSize , InvalidDiagonalMatrix , GradientMagnitudeTolerance , LineSearchError }
using | Superclass = ScaledSingleValuedNonLinearOptimizer
Public Types inherited from itk::ScaledSingleValuedNonLinearOptimizer
using | ConstPointer = SmartPointer<const Self>
using | Pointer = SmartPointer<Self>
using | ScaledCostFunctionPointer = ScaledCostFunctionType::Pointer
using | ScaledCostFunctionType = ScaledSingleValuedCostFunction
using | ScalesType = NonLinearOptimizer::ScalesType
using | Self = ScaledSingleValuedNonLinearOptimizer
using | Superclass = SingleValuedNonLinearOptimizer
Public Types inherited from elastix::OptimizerBase< TElastix >
using | ElastixType
using | ITKBaseType = itk::Optimizer
using | ParametersType = typename ITKBaseType::ParametersType
using | RegistrationType
using | Self = OptimizerBase
using | Superclass = BaseComponentSE<TElastix>
Public Types inherited from elastix::BaseComponentSE< TElastix >
using | ElastixType = TElastix
using | RegistrationType = typename ElastixType::RegistrationBaseType
using | Self = BaseComponentSE
using | Superclass = BaseComponent

## Public Member Functions

void | AdvanceOneStep () override
void | AfterEachIteration () override
void | AfterEachResolution () override
void | AfterRegistration () override
void | BeforeEachResolution () override
void | BeforeRegistration () override
| elxClassNameMacro ("AdaptiveStochasticVarianceReducedGradient")
virtual bool | GetAutomaticParameterEstimation () const
virtual const char * | GetClassName () const
virtual const SizeValueType & | GetMaximumNumberOfSamplingAttempts ()
virtual double | GetMaximumStepLength () const
virtual const DerivativeType & | GetMeanGradient ()
| ITK_DISALLOW_COPY_AND_MOVE (AdaptiveStochasticVarianceReducedGradient)
void | MetricErrorResponse (itk::ExceptionObject &err) override
void | ResumeOptimization () override
virtual void | SetAutomaticParameterEstimation (bool _arg)
virtual void | SetMaximumNumberOfSamplingAttempts (SizeValueType _arg)
virtual void | SetMaximumStepLength (double _arg)
void | SetNumberOfWorkUnits (ThreadIdType numberOfThreads)
void | StartOptimization () override
void | StopOptimization () override
Public Member Functions inherited from itk::AdaptiveStochasticVarianceReducedGradientOptimizer
virtual double | GetSigmoidMax () const
virtual double | GetSigmoidMin () const
virtual double | GetSigmoidScale () const
virtual bool | GetUseAdaptiveStepSizes () const
| ITK_DISALLOW_COPY_AND_MOVE (AdaptiveStochasticVarianceReducedGradientOptimizer)
virtual void | SetSigmoidMax (double _arg)
virtual void | SetSigmoidMin (double _arg)
virtual void | SetSigmoidScale (double _arg)
virtual void | SetUseAdaptiveStepSizes (bool _arg)
Public Member Functions inherited from itk::StandardStochasticVarianceReducedGradientOptimizer
void | AdvanceOneStep () override
virtual double | GetCurrentTime () const
virtual double | GetInitialTime () const
virtual double | GetParam_A () const
virtual double | GetParam_a () const
virtual double | GetParam_alpha () const
virtual double | GetParam_beta () const
| ITK_DISALLOW_COPY_AND_MOVE (StandardStochasticVarianceReducedGradientOptimizer)
virtual void | ResetCurrentTimeToInitialTime ()
virtual void | SetInitialTime (double _arg)
virtual void | SetParam_A (double _arg)
virtual void | SetParam_a (double _arg)
virtual void | SetParam_alpha (double _arg)
virtual void | SetParam_beta (double _arg)
void | StartOptimization () override
Public Member Functions inherited from itk::StochasticVarianceReducedGradientDescentOptimizer
virtual unsigned int | GetCurrentInnerIteration () const
virtual unsigned int | GetCurrentIteration () const
virtual const DerivativeType & | GetGradient ()
virtual unsigned int | GetLBFGSMemory () const
virtual const double & | GetLearningRate ()
virtual const unsigned long & | GetNumberOfInnerIterations ()
virtual const unsigned long & | GetNumberOfIterations ()
virtual const DerivativeType & | GetPreviousGradient ()
virtual const ParametersType & | GetPreviousPosition ()
virtual const DerivativeType & | GetSearchDir ()
virtual const StopConditionType & | GetStopCondition ()
virtual const double & | GetValue ()
| ITK_DISALLOW_COPY_AND_MOVE (StochasticVarianceReducedGradientDescentOptimizer)
virtual void | MetricErrorResponse (ExceptionObject &err)
virtual void | SetLearningRate (double _arg)
virtual void | SetNumberOfIterations (unsigned long _arg)
void | SetNumberOfWorkUnits (ThreadIdType numberOfThreads)
virtual void | SetPreviousGradient (DerivativeType _arg)
virtual void | SetPreviousPosition (ParametersType _arg)
virtual void | SetUseEigen (bool _arg)
virtual void | SetUseMultiThread (bool _arg)
void | StartOptimization () override
Public Member Functions inherited from itk::ScaledSingleValuedNonLinearOptimizer
const ParametersType & | GetCurrentPosition () const override
virtual bool | GetMaximize () const
virtual const ScaledCostFunctionType * | GetScaledCostFunction ()
virtual const ParametersType & | GetScaledCurrentPosition ()
bool | GetUseScales () const
virtual void | InitializeScales ()
| ITK_DISALLOW_COPY_AND_MOVE (ScaledSingleValuedNonLinearOptimizer)
virtual void | MaximizeOff ()
virtual void | MaximizeOn ()
void | SetCostFunction (CostFunctionType *costFunction) override
virtual void | SetMaximize (bool _arg)
virtual void | SetUseScales (bool arg)
Public Member Functions inherited from elastix::OptimizerBase< TElastix >
void | AfterRegistrationBase () override
void | BeforeEachResolutionBase () override
ITKBaseType * | GetAsITKBaseType ()
const ITKBaseType * | GetAsITKBaseType () const
| ITK_DISALLOW_COPY_AND_MOVE (OptimizerBase)
virtual void | SetCurrentPositionPublic (const ParametersType &param)
virtual void | SetSinusScales (double amplitude, double frequency, unsigned long numberOfParameters)
Public Member Functions inherited from elastix::BaseComponentSE< TElastix >
void | AddTargetCellToIterationInfo (const char *const name)
const Configuration * | GetConfiguration () const
ElastixType * | GetElastix () const
auto & | GetIterationInfoAt (const char *const name)
RegistrationType * | GetRegistration () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponentSE)
void | RemoveTargetCellFromIterationInfo (const char *const name)
void | SetConfiguration (const Configuration *_arg)
void | SetElastix (ElastixType *_arg)
Public Member Functions inherited from elastix::BaseComponent
virtual void | AfterEachIterationBase ()
virtual void | AfterEachResolutionBase ()
virtual int | BeforeAll ()
virtual int | BeforeAllBase ()
virtual void | BeforeRegistrationBase ()
virtual const char * | elxGetClassName () const
const char * | GetComponentLabel () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponent)
| itkTypeMacroNoParent (BaseComponent)
void | SetComponentLabel (const char *label, unsigned int idx)

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::AdaptiveStochasticVarianceReducedGradientOptimizer
static Pointer | New ()
Static Public Member Functions inherited from itk::StandardStochasticVarianceReducedGradientOptimizer
static Pointer | New ()
Static Public Member Functions inherited from itk::StochasticVarianceReducedGradientDescentOptimizer
static Pointer | New ()
Static Public Member Functions inherited from itk::ScaledSingleValuedNonLinearOptimizer
static Pointer | New ()
Static Public Member Functions inherited from elastix::BaseComponent
template<typename TBaseComponent>
static auto | AsITKBaseType (TBaseComponent *const baseComponent) -> decltype(baseComponent->GetAsITKBaseType())
static void | InitializeElastixExecutable ()
static bool | IsElastixLibrary ()

## Protected Types

using | AdvancedTransformType
using | ComputeDisplacementDistributionType = itk::ComputeDisplacementDistribution<FixedImageType, TransformType>
using | ComputeJacobianTermsType = itk::ComputeJacobianTerms<FixedImageType, TransformType>
using | CoordinateRepresentationType = typename TransformType::ScalarType
using | FixedImageIndexType = typename FixedImageType::IndexType
using | FixedImagePointType = typename FixedImageType::PointType
using | FixedImageRegionType = typename FixedImageType::RegionType
using | FixedImageType = typename RegistrationType::FixedImageType
using | ImageGridSamplerPointer = typename ImageGridSamplerType::Pointer
using | ImageGridSamplerType = itk::ImageGridSampler<FixedImageType>
using | ImageRadomSampleContainerPointer = typename ImageRadomSampleContainerType::Pointer
using | ImageRadomSampleContainerType = typename ImageRandomSamplerType::ImageSampleContainerType
using | ImageRandomCoordinateSamplerPointer = typename ImageRandomCoordinateSamplerType::Pointer
using | ImageRandomCoordinateSamplerType = itk::ImageRandomCoordinateSampler<FixedImageType>
using | ImageRandomSamplerBasePointer = typename ImageRandomSamplerBaseType::Pointer
using | ImageRandomSamplerBaseType = itk::ImageRandomSamplerBase<FixedImageType>
using | ImageRandomSamplerPointer = typename ImageRandomSamplerType::Pointer
using | ImageRandomSamplerType = itk::ImageRandomSampler<FixedImageType>
using | ImageSampleContainerPointer = typename ImageSampleContainerType::Pointer
using | ImageSampleContainerType = typename ImageGridSamplerType::ImageSampleContainerType
using | ImageSamplerBasePointer = typename ImageSamplerBaseType::Pointer
using | ImageSamplerBaseType = itk::ImageSamplerBase<FixedImageType>
using | ImageSampleType = typename ImageSamplerBaseType::ImageSampleType
using | itkRegistrationType = typename RegistrationType::ITKBaseType
using | JacobianType = typename TransformType::JacobianType
using | JacobianValueType = typename JacobianType::ValueType
using | MovingImageType = typename RegistrationType::MovingImageType
using | NonZeroJacobianIndicesType = typename AdvancedTransformType::NonZeroJacobianIndicesType
using | RandomGeneratorType = itk::Statistics::MersenneTwisterRandomVariateGenerator
using | SettingsVectorType
using | TransformJacobianType = JacobianType
using | TransformType = typename itkRegistrationType::TransformType
Protected Types inherited from itk::StochasticVarianceReducedGradientDescentOptimizer
using | ThreadInfoType = MultiThreaderBase::WorkUnitInfo
Protected Types inherited from elastix::OptimizerBase< TElastix >
using | SettingsVectorType = typename std::vector<SettingsType>

## Protected Member Functions

| AdaptiveStochasticVarianceReducedGradient ()
virtual void | AddRandomPerturbation (ParametersType &parameters, double sigma)
virtual void | AutomaticParameterEstimation ()
virtual void | AutomaticParameterEstimationOriginal ()
virtual void | AutomaticParameterEstimationUsingDisplacementDistribution ()
virtual void | GetScaledDerivativeWithExceptionHandling (const ParametersType &parameters, DerivativeType &derivative)
| itkStaticConstMacro (FixedImageDimension, unsigned int, FixedImageType::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, MovingImageType::ImageDimension)
virtual void | SampleGradients (const ParametersType &mu0, double perturbationSigma, double &gg, double &ee)
| ~AdaptiveStochasticVarianceReducedGradient () override=default
Protected Member Functions inherited from itk::AdaptiveStochasticVarianceReducedGradientOptimizer
| AdaptiveStochasticVarianceReducedGradientOptimizer ()
void | UpdateCurrentTime () override
| ~AdaptiveStochasticVarianceReducedGradientOptimizer () override=default
Protected Member Functions inherited from itk::StandardStochasticVarianceReducedGradientOptimizer
virtual double | Compute_a (double k) const
virtual double | Compute_beta (double k) const
| StandardStochasticVarianceReducedGradientOptimizer ()
| ~StandardStochasticVarianceReducedGradientOptimizer () override=default
Protected Member Functions inherited from itk::StochasticVarianceReducedGradientDescentOptimizer
void | PrintSelf (std::ostream &os, Indent indent) const override
| StochasticVarianceReducedGradientDescentOptimizer ()
| ~StochasticVarianceReducedGradientDescentOptimizer () override=default
Protected Member Functions inherited from itk::ScaledSingleValuedNonLinearOptimizer
virtual void | GetScaledDerivative (const ParametersType &parameters, DerivativeType &derivative) const
virtual MeasureType | GetScaledValue (const ParametersType &parameters) const
virtual void | GetScaledValueAndDerivative (const ParametersType &parameters, MeasureType &value, DerivativeType &derivative) const
void | PrintSelf (std::ostream &os, Indent indent) const override
| ScaledSingleValuedNonLinearOptimizer ()
void | SetCurrentPosition (const ParametersType &param) override
virtual void | SetScaledCurrentPosition (const ParametersType &parameters)
| ~ScaledSingleValuedNonLinearOptimizer () override=default
Protected Member Functions inherited from elastix::OptimizerBase< TElastix >
virtual bool | GetNewSamplesEveryIteration () const
| OptimizerBase ()=default
virtual void | SelectNewSamples ()
| ~OptimizerBase () override=default
Protected Member Functions inherited from elastix::BaseComponentSE< TElastix >
| BaseComponentSE ()=default
| ~BaseComponentSE () override=default
Protected Member Functions inherited from elastix::BaseComponent
| BaseComponent ()=default
virtual | ~BaseComponent ()=default

## Protected Attributes

AdvancedTransformType::Pointer | m_AdvancedTransform
DerivativeType | m_ExactGradient
DerivativeType | m_MeanGradient
double | m_NoiseFactor
SizeValueType | m_NumberOfGradientMeasurements
SizeValueType | m_NumberOfJacobianMeasurements
SizeValueType | m_NumberOfSamplesForExactGradient
RandomGeneratorType::Pointer | m_RandomGenerator
SettingsVectorType | m_SettingsVector
double | m_SigmoidScaleFactor
Protected Attributes inherited from itk::AdaptiveStochasticVarianceReducedGradientOptimizer
DerivativeType | m_PreviousGradient {}
Protected Attributes inherited from itk::StandardStochasticVarianceReducedGradientOptimizer
double | m_CurrentTime { 0.0 }
bool | m_UseConstantStep {}
Protected Attributes inherited from itk::StochasticVarianceReducedGradientDescentOptimizer
unsigned long | m_CurrentInnerIteration {}
unsigned long | m_CurrentIteration { 0 }
DerivativeType | m_Gradient {}
unsigned long | m_LBFGSMemory { 0 }
double | m_LearningRate { 1.0 }
ParametersType | m_MeanSearchDir {}
unsigned long | m_NumberOfInnerIterations {}
unsigned long | m_NumberOfIterations { 100 }
DerivativeType | m_PreviousGradient {}
ParametersType | m_PreviousPosition {}
ParametersType | m_PreviousSearchDir {}
ParametersType | m_SearchDir {}
bool | m_Stop { false }
StopConditionType | m_StopCondition { MaximumNumberOfIterations }
MultiThreaderBase::Pointer | m_Threader { MultiThreaderBase::New() }
double | m_Value { 0.0 }
Protected Attributes inherited from itk::ScaledSingleValuedNonLinearOptimizer
ScaledCostFunctionPointer | m_ScaledCostFunction {}
ParametersType | m_ScaledCurrentPosition {}
Protected Attributes inherited from elastix::BaseComponentSE< TElastix >
Configuration::ConstPointer | m_Configuration {}
itk::WeakPointer< TElastix > | m_Elastix {}
RegistrationType * | m_Registration {}

## Private Member Functions

void | ThreadedAdvanceOneStep (ThreadIdType threadId, ParametersType &newPosition)

## Static Private Member Functions

static itk::ITK_THREAD_RETURN_TYPE | AdvanceOneStepThreaderCallback (void *arg)

## Private Attributes

| elxOverrideGetSelfMacro
bool | m_AutomaticParameterEstimation
bool | m_AutomaticParameterEstimationDone
SizeValueType | m_CurrentNumberOfSamplingAttempts
SizeValueType | m_MaxBandCovSize
SizeValueType | m_MaximumNumberOfSamplingAttempts
double | m_MaximumStepLength
SizeValueType | m_NumberOfBandStructureSamples
SizeValueType | m_NumberOfInnerLoopSamples
SizeValueType | m_NumberOfSpatialSamples
bool | m_OriginalButSigmoidToDefault
SizeValueType | m_OutsideIterations
SizeValueType | m_PreviousErrorAtIteration
bool | m_UseNoiseCompensation
bool | m_UseNoiseFactor

## Additional Inherited Members

Static Protected Member Functions inherited from elastix::OptimizerBase< TElastix >
static void | PrintSettingsVector (const SettingsVectorType &settings)

## Member Typedef Documentation

## AdvancedTransformType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AdvancedTransformType

protected

Initial value:
itk::AdvancedTransform<CoordinateRepresentationType, Self::FixedImageDimension, Self::MovingImageDimension>
itk::AdvancedTransform
Transform maps points, vectors and covariant vectors from an input space to an output space.
Definition itkAdvancedTransform.h:84

Definition at line 354 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ComputeDisplacementDistributionType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ComputeDisplacementDistributionType = itk::ComputeDisplacementDistribution<FixedImageType, TransformType>

protected

Definition at line 323 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ComputeJacobianTermsType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ComputeJacobianTermsType = itk::ComputeJacobianTerms<FixedImageType, TransformType>

protected

Definition at line 319 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ConstPointer

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ConstPointer = itk::SmartPointer<const Self>

Definition at line 205 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## CoordinateRepresentationType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::CoordinateRepresentationType = typename TransformType::ScalarType

protected

Definition at line 353 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## FixedImageIndexType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::FixedImageIndexType = typename FixedImageType::IndexType

protected

Definition at line 314 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## FixedImagePointType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::FixedImagePointType = typename FixedImageType::PointType

protected

Definition at line 315 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## FixedImageRegionType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::FixedImageRegionType = typename FixedImageType::RegionType

protected

Definition at line 313 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## FixedImageType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::FixedImageType = typename RegistrationType::FixedImageType

protected

Protected typedefs

Definition at line 310 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageGridSamplerPointer

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageGridSamplerPointer = typename ImageGridSamplerType::Pointer

protected

Definition at line 342 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageGridSamplerType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageGridSamplerType = itk::ImageGridSampler<FixedImageType>

protected

Image grid sampler.

Definition at line 341 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageRadomSampleContainerPointer

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageRadomSampleContainerPointer = typename ImageRadomSampleContainerType::Pointer

protected

Definition at line 338 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageRadomSampleContainerType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageRadomSampleContainerType = typename ImageRandomSamplerType::ImageSampleContainerType

protected

Definition at line 337 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageRandomCoordinateSamplerPointer

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageRandomCoordinateSamplerPointer = typename ImageRandomCoordinateSamplerType::Pointer

protected

Definition at line 331 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageRandomCoordinateSamplerType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageRandomCoordinateSamplerType = itk::ImageRandomCoordinateSampler<FixedImageType>

protected

Definition at line 330 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageRandomSamplerBasePointer

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageRandomSamplerBasePointer = typename ImageRandomSamplerBaseType::Pointer

protected

Definition at line 329 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageRandomSamplerBaseType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageRandomSamplerBaseType = itk::ImageRandomSamplerBase<FixedImageType>

protected

Definition at line 328 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageRandomSamplerPointer

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageRandomSamplerPointer = typename ImageRandomSamplerType::Pointer

protected

Definition at line 336 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageRandomSamplerType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageRandomSamplerType = itk::ImageRandomSampler<FixedImageType>

protected

Image random sampler.

Definition at line 335 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageSampleContainerPointer

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageSampleContainerPointer = typename ImageSampleContainerType::Pointer

protected

Definition at line 344 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageSampleContainerType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageSampleContainerType = typename ImageGridSamplerType::ImageSampleContainerType

protected

Definition at line 343 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageSamplerBasePointer

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageSamplerBasePointer = typename ImageSamplerBaseType::Pointer

protected

Definition at line 327 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageSamplerBaseType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageSamplerBaseType = itk::ImageSamplerBase<FixedImageType>

protected

Samplers:

Definition at line 326 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ImageSampleType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ImageSampleType = typename ImageSamplerBaseType::ImageSampleType

protected

Definition at line 332 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ITKBaseType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ITKBaseType = typename Superclass2::ITKBaseType

Definition at line 227 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## itkRegistrationType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::itkRegistrationType = typename RegistrationType::ITKBaseType

protected

Definition at line 316 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## JacobianType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::JacobianType = typename TransformType::JacobianType

protected

Definition at line 318 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## JacobianValueType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::JacobianValueType = typename JacobianType::ValueType

protected

Definition at line 320 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## MovingImageType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::MovingImageType = typename RegistrationType::MovingImageType

protected

Definition at line 311 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## NonZeroJacobianIndicesType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::NonZeroJacobianIndicesType = typename AdvancedTransformType::NonZeroJacobianIndicesType

protected

Definition at line 356 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## Pointer

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::Pointer = itk::SmartPointer<Self>

Definition at line 204 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## RandomGeneratorType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::RandomGeneratorType = itk::Statistics::MersenneTwisterRandomVariateGenerator

protected

Other protected typedefs

Definition at line 347 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## Self

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::Self = AdaptiveStochasticVarianceReducedGradient

Standard ITK.

Definition at line 201 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## SettingsVectorType

template<class TElastix>

using elastix::OptimizerBase< TElastix >::SettingsVectorType

protected

Definition at line 133 of file elxOptimizerBase.h.

## SizeValueType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::SizeValueType = itk::SizeValueType

Definition at line 228 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## Superclass1

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::Superclass1 = AdaptiveStochasticVarianceReducedGradientOptimizer

Definition at line 202 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## Superclass2

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::Superclass2 = OptimizerBase<TElastix>

Definition at line 203 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## ThreadIdType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ThreadIdType = unsigned int

Type to count and reference number of threads

Definition at line 299 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## TransformJacobianType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::TransformJacobianType = JacobianType

protected

Typedefs for support of sparse Jacobians and AdvancedTransforms.

Definition at line 350 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## TransformType

template<class TElastix>

using elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::TransformType = typename itkRegistrationType::TransformType

protected

Definition at line 317 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## Constructor & Destructor Documentation

## AdaptiveStochasticVarianceReducedGradient()

template<class TElastix>

elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AdaptiveStochasticVarianceReducedGradient | ( |  | ) |

protected

## ~AdaptiveStochasticVarianceReducedGradient()

template<class TElastix>

elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::~AdaptiveStochasticVarianceReducedGradient | ( |  | ) |

override protected default

## Member Function Documentation

## AddRandomPerturbation()

template<class TElastix>

virtual void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AddRandomPerturbation | ( | ParametersType & | parameters,
|  | double | sigma )

protected virtual

Helper function that adds a random perturbation delta to the input parameters, with delta ~ sigma * N(0,I). Used by SampleGradients.

## AdvanceOneStep()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AdvanceOneStep | ( |  | ) |

override virtual

Advance one step following the gradient direction.

Reimplemented from itk::StochasticVarianceReducedGradientDescentOptimizer.

## AdvanceOneStepThreaderCallback()

template<class TElastix>

itk::ITK_THREAD_RETURN_TYPE elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AdvanceOneStepThreaderCallback | ( | void * | arg | ) |

static private

The callback function.

## AfterEachIteration()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AfterEachIteration | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## AfterEachResolution()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AfterEachResolution | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## AfterRegistration()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AfterRegistration | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## AutomaticParameterEstimation()

template<class TElastix>

virtual void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AutomaticParameterEstimation | ( |  | ) |

protected virtual

Select different method to estimate some reasonable values for the parameters SP_a, SP_alpha (=1), SigmoidMin, SigmoidMax (=1), and SigmoidScale.

## AutomaticParameterEstimationOriginal()

template<class TElastix>

virtual void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AutomaticParameterEstimationOriginal | ( |  | ) |

protected virtual

Original estimation method to get the reasonable values for the parameters SP_a, SP_alpha (=1), SigmoidMin, SigmoidMax (=1), and SigmoidScale.

## AutomaticParameterEstimationUsingDisplacementDistribution()

template<class TElastix>

virtual void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::AutomaticParameterEstimationUsingDisplacementDistribution | ( |  | ) |

protected virtual

Estimates some reasonable values for the parameters using displacement distribution SP_a, SP_alpha (=1)

## BeforeEachResolution()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::BeforeEachResolution | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## BeforeRegistration()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::BeforeRegistration | ( |  | ) |

override virtual

Methods invoked by elastix, in which parameters can be set and progress information can be printed.

Reimplemented from elastix::BaseComponent.

## elxClassNameMacro()

template<class TElastix>

elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::elxClassNameMacro | ( | "AdaptiveStochasticVarianceReducedGradient< TElastix >" |  | ) |

Name of this class. Use this name in the parameter file to select this specific optimizer. example: (Optimizer "AdaptiveStochasticVarianceReducedGradient")

## GetAutomaticParameterEstimation()

template<class TElastix>

virtual bool elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::GetAutomaticParameterEstimation | ( |  | ) | const

virtual

## GetClassName()

template<class TElastix>

virtual const char * elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::AdaptiveStochasticVarianceReducedGradientOptimizer.

## GetMaximumNumberOfSamplingAttempts()

template<class TElastix>

virtual const SizeValueType & elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::GetMaximumNumberOfSamplingAttempts | ( |  | ) |

virtual

Get the MaximumNumberOfSamplingAttempts.

## GetMaximumStepLength()

template<class TElastix>

virtual double elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::GetMaximumStepLength | ( |  | ) | const

virtual

## GetMeanGradient()

template<class TElastix>

virtual const DerivativeType & elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::GetMeanGradient | ( |  | ) |

virtual

Get the Previous gradient.

## GetScaledDerivativeWithExceptionHandling()

template<class TElastix>

virtual void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::GetScaledDerivativeWithExceptionHandling | ( | const ParametersType & | parameters,
|  | DerivativeType & | derivative )

protected virtual

Helper function, which calls GetScaledValueAndDerivative and does some exception handling. Used by SampleGradients.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TElastix>

elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ITK_DISALLOW_COPY_AND_MOVE | ( | AdaptiveStochasticVarianceReducedGradient< TElastix > |  | ) |

## itkStaticConstMacro() [1/2]

template<class TElastix>

elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::itkStaticConstMacro | ( | FixedImageDimension | ,
|  | unsigned int | ,
|  | FixedImageType::ImageDimension | )

protected

## itkStaticConstMacro() [2/2]

template<class TElastix>

elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::itkStaticConstMacro | ( | MovingImageDimension | ,
|  | unsigned int | ,
|  | MovingImageType::ImageDimension | )

protected

## MetricErrorResponse()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::MetricErrorResponse | ( | itk::ExceptionObject & | err | ) |

override

Stop optimization and pass on exception.

## New()

template<class TElastix>

Pointer elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::New | ( |  | ) |

static

Method for creation through the object factory.

## ResumeOptimization()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ResumeOptimization | ( |  | ) |

override virtual

If automatic gain estimation is desired, then estimate SP_a, SP_alpha SigmoidScale, SigmoidMax, SigmoidMin. After that call Superclass' implementation.

Reimplemented from itk::StochasticVarianceReducedGradientDescentOptimizer.

## SampleGradients()

template<class TElastix>

virtual void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::SampleGradients | ( | const ParametersType & | mu0,
|  | double | perturbationSigma,
|  | double & | gg,
|  | double & | ee )

protected virtual

Measure some derivatives, exact and approximated. Returns the squared magnitude of the gradient and approximation error. Needed for the automatic parameter estimation. Gradients are measured at position mu_n, which are generated according to: mu_n - mu_0 ~ N(0, perturbationSigma^2 I ); gg = g^T g, etc.

## SetAutomaticParameterEstimation()

template<class TElastix>

virtual void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::SetAutomaticParameterEstimation | ( | bool | _arg | ) |

virtual

Set/Get whether automatic parameter estimation is desired. If true, make sure to set the maximum step length.

The following parameters are automatically determined: SP_a, SP_alpha (=1), SigmoidMin, SigmoidMax (=1), SigmoidScale. A usually suitable value for SP_A is 20, which is the default setting, if not specified by the user.

## SetMaximumNumberOfSamplingAttempts()

template<class TElastix>

virtual void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::SetMaximumNumberOfSamplingAttempts | ( | SizeValueType | _arg | ) |

virtual

Set the MaximumNumberOfSamplingAttempts.

## SetMaximumStepLength()

template<class TElastix>

virtual void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::SetMaximumStepLength | ( | double | _arg | ) |

virtual

Set/Get maximum step length.

## SetNumberOfWorkUnits()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::SetNumberOfWorkUnits | ( | ThreadIdType | numberOfThreads | ) |

inline

Set the number of threads.

Definition at line 303 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## StartOptimization()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::StartOptimization | ( |  | ) |

override

Check if any scales are set, and set the UseScales flag on or off; after that call the superclass' implementation.

## StopOptimization()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::StopOptimization | ( |  | ) |

override virtual

Stop optimization.

See also
  ResumeOptimization

Reimplemented from itk::StochasticVarianceReducedGradientDescentOptimizer.

## ThreadedAdvanceOneStep()

template<class TElastix>

void elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::ThreadedAdvanceOneStep | ( | ThreadIdType | threadId,
|  | ParametersType & | newPosition )

inline private

The threaded implementation of AdvanceOneStep().

## Field Documentation

## elxOverrideGetSelfMacro

template<class TElastix>

elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::elxOverrideGetSelfMacro

private

Definition at line 425 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_AdvancedTransform

template<class TElastix>

AdvancedTransformType::Pointer elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_AdvancedTransform

protected

The transform stored as AdvancedTransform

Definition at line 370 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_AutomaticParameterEstimation

template<class TElastix>

bool elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_AutomaticParameterEstimation

private

Definition at line 442 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_AutomaticParameterEstimationDone

template<class TElastix>

bool elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_AutomaticParameterEstimationDone

private

Definition at line 449 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_CurrentNumberOfSamplingAttempts

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_CurrentNumberOfSamplingAttempts

private

Definition at line 447 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_ExactGradient

template<class TElastix>

DerivativeType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_ExactGradient

protected

Definition at line 419 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_MaxBandCovSize

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_MaxBandCovSize

private

Private variables for band size estimation of covariance matrix.

Definition at line 454 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_MaximumNumberOfSamplingAttempts

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_MaximumNumberOfSamplingAttempts

private

Private variables for the sampling attempts.

Definition at line 446 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_MaximumStepLength

template<class TElastix>

double elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_MaximumStepLength

private

Definition at line 443 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_MeanGradient

template<class TElastix>

DerivativeType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_MeanGradient

protected

Definition at line 420 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_NoiseFactor

template<class TElastix>

double elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_NoiseFactor

protected

Definition at line 422 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_NumberOfBandStructureSamples

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_NumberOfBandStructureSamples

private

Definition at line 455 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_NumberOfGradientMeasurements

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_NumberOfGradientMeasurements

protected

Some options for automatic parameter estimation.

Definition at line 365 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_NumberOfInnerLoopSamples

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_NumberOfInnerLoopSamples

private

Definition at line 456 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_NumberOfJacobianMeasurements

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_NumberOfJacobianMeasurements

protected

Definition at line 366 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_NumberOfSamplesForExactGradient

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_NumberOfSamplesForExactGradient

protected

Definition at line 367 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_NumberOfSpatialSamples

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_NumberOfSpatialSamples

private

Definition at line 457 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_OriginalButSigmoidToDefault

template<class TElastix>

bool elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_OriginalButSigmoidToDefault

private

Definition at line 461 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_OutsideIterations

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_OutsideIterations

private

Definition at line 451 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_PreviousErrorAtIteration

template<class TElastix>

SizeValueType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_PreviousErrorAtIteration

private

Definition at line 448 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_RandomGenerator

template<class TElastix>

RandomGeneratorType::Pointer elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_RandomGenerator

protected

RandomGenerator for AddRandomPerturbation.

Definition at line 373 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_SettingsVector

template<class TElastix>

SettingsVectorType elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_SettingsVector

protected

Variable to store the automatically determined settings for each resolution.

Definition at line 362 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_SigmoidScaleFactor

template<class TElastix>

double elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_SigmoidScaleFactor

protected

Definition at line 375 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_UseNoiseCompensation

template<class TElastix>

bool elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_UseNoiseCompensation

private

The flag of using noise compensation.

Definition at line 460 of file elxAdaptiveStochasticVarianceReducedGradient.h.

## m_UseNoiseFactor

template<class TElastix>

bool elastix::AdaptiveStochasticVarianceReducedGradient< TElastix >::m_UseNoiseFactor

private

Definition at line 462 of file elxAdaptiveStochasticVarianceReducedGradient.h.

Generated on 1768596610 for elastix by 1.15.0 |